<?php
/**
* @version      2.6.0 25.11.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined('_JEXEC') or die( 'Restricted access' );
jimport('joomla.application.component.model');

class jshopCart{
    
    var $type_cart = "cart"; //cart,wishlist
    var $products = array();
    var $count_product = 0;
    var $price_product = 0;
    var $summ = 0;
    var $rabatt_id = 0;
    var $rabatt_value = 0;
    var $rabatt_type = 0;
    var $rabatt_summ = 0;    
    
    function load($type_cart = "cart") {
        $jshopConfig = &JSFactory::getConfig();
        $this->type_cart = $type_cart;
        
        $session =& JFactory::getSession();
        $objcart = $session->get($this->type_cart);
                
        if (isset($objcart) && $objcart!='') {        
            $temp_cart = unserialize($objcart);            
            $this->products = $temp_cart->products;
            $this->rabatt_id = $temp_cart->rabatt_id;
            $this->rabatt_value = $temp_cart->rabatt_value;
            $this->rabatt_type = $temp_cart->rabatt_type;
            $this->rabatt_summ = $temp_cart->rabatt_summ;            
        }
        
        if(isset($_COOKIE['jshopping_temp_cart']) && $this->type_cart=='wishlist' && !count($this->products)) {
            $_tempcart = &JModel::getInstance('tempcart', 'jshop');
            $products = $_tempcart->getTempCart($_COOKIE['jshopping_temp_cart'], $this->type_cart);            
            if (count($products)){
                $this->products = $products;    
                $this->saveToSession();
            }            
        }
        
        $this->loadPriceAndCountProducts();
        if ($jshopConfig->use_extend_tax_rule){
            $this->updateTaxForProducts();
            $this->saveToSession();
        }
    }
    
    function loadPriceAndCountProducts(){
        $this->price_product = 0;
        $this->count_product = 0;
        if(count($this->products)) {
            foreach ($this->products as $prod) {
                $this->price_product += $prod['price'] * $prod['quantity'];
                $this->count_product += $prod['quantity'];
            }
        }
    }
    
    function getPriceProducts(){
        return $this->price_product;
    }
    
    function getCountProduct(){
        return $this->count_product;
    }
    
    function updateTaxForProducts(){
        if(count($this->products)) {
            $taxes = &JSFactory::getAllTaxes();
            foreach ($this->products as $k=>$prod) {
                $this->products[$k]['tax'] = $taxes[$prod['tax_id']];
            }
        }
    }
    
    /**
    * get cart summ price
    * @param mixed $incShiping - include price shipping
    * @param mixed $incRabatt - include discount
    * @param mixed $incPayment - include price payment
    */
    function getSum( $incShiping = 0, $incRabatt = 0, $incPayment = 0 ) {
        $jshopConfig = &JSFactory::getConfig();
        
        $this->summ = $this->price_product;
        
        if ($jshopConfig->display_price_front_current==1){            
            $this->summ = $this->summ + $this->getTax($incShiping, $incRabatt, $incPayment);
        }        
                
        if ($incShiping){
            $price_shipping = $this->getShippingPrice();
            $this->summ = $this->summ + $price_shipping;
        }
        
        if ($incPayment){
            $price_payment = $this->getPaymentPrice();
            $this->summ = $this->summ + $price_payment;
        }
        
        if ($incRabatt){
            $this->summ = $this->summ - $this->getDiscountShow();
            if ($this->summ < 0) $this->summ = 0;
        }
        
        return $this->summ;
    }
    
    function getDiscountShow(){
        $summForCalculeDiscount = $this->getSummForCalculeDiscount();
        if ($this->rabatt_summ > $summForCalculeDiscount){
            return $summForCalculeDiscount;
        }else{
            return $this->rabatt_summ;
        }
    }
    
    function getFreeDiscount(){
        $summForCalculeDiscount = $this->getSummForCalculeDiscount();
        if ($this->rabatt_summ > $summForCalculeDiscount){
            return $this->rabatt_summ - $summForCalculeDiscount;
        }else{
            return 0;
        }
    }

    /*function getSumNetto() {
        $summ = 0;
        foreach ($this->products as $prod) {
            $summ += $prod['price_netto'] * $prod['quantity'];
        }
        return round($summ, 2);
    }*/    

    /**
    * get cart tax    
    * @param mixed $incShiping - include price shipping
    * @param mixed $incRabatt - not used
    * @param mixed $incPayment - include price payment
    */
    function getTax( $incShiping = 0, $incRabatt = 0, $incPayment = 0) {
        $jshopConfig = &JSFactory::getConfig();
        
        $tax_summ = 0;
        foreach ($this->products as $key => $value) {            
            $tax_summ += $value['quantity'] * getPriceTaxValue($value['price'], $value['tax'], $jshopConfig->display_price_front_current);
        }
        
        if ($incShiping){
            $tax_summ += $this->getShippingPriceTax();
        }
        
        if ($incPayment){
            $tax_summ += $this->getPaymentTax();    
        }
        
        return $tax_summ;
    }
    
    /**
    * get cart tax    
    * @param mixed $incShiping - include price shipping
    * @param mixed $incRabatt - not used
    * @param mixed $incPayment - include price payment
    */
    function getTaxExt( $incShiping = 0, $incRabatt = 0, $incPayment = 0) {
        $jshopConfig = &JSFactory::getConfig();
        
        $tax_summ = array();
        foreach ($this->products as $key => $value) {
            if ($value['tax']!=0){
                $tax_summ[$value['tax']] += $value['quantity'] * getPriceTaxValue($value['price'], $value['tax'], $jshopConfig->display_price_front_current);
            }
        }
                
        if ($incShiping){
            if ($this->getShippingPriceTaxPercent()!=0 && $this->getShippingPriceTax()!=0){                
                $tax_summ[$this->getShippingPriceTaxPercent()] += $this->getShippingPriceTax();
            }
        }
        
        if ($incPayment){
            if ($this->getPaymentTaxPercent()!=0 && $this->getPaymentTax()!=0){
                $tax_summ[$this->getPaymentTaxPercent()] += $this->getPaymentTax();
            }
        }
        
        return $tax_summ;
    }
    
    /*function getPercentDiscount(){
        $jshopConfig = &JSFactory::getConfig();        
        if ($this->rabatt_type == 1) {
           $discountsum = $this->rabatt_value * $jshopConfig->currency_value;
           $sum = $this->getSum();            
           if ($sum == 0) return 0;
           $percent = ($discountsum / $sum * 100);
           if ($percent > 100) $percent = 100;
           return $percent;
        } else {
            return $this->rabatt_value;
        }    
    }*/
    
    function setDisplayItem($shipping = 0, $payment = 0){
        $this->display_item_shipping = $shipping;
        $this->display_item_payment = $payment;
    }
    
    function setShippingId($val){
        $session =& JFactory::getSession();
        $session->set("shipping_method_id", $val);
    }
    
    function getShippingId() {
        $session =& JFactory::getSession();        
        return $session->get("shipping_method_id");
    }
    
    function setShippingPrId($val){
        $session =& JFactory::getSession();
        $session->set("sh_pr_method_id", $val);
    }
    
    function getShippingPrId() {
        $session =& JFactory::getSession();        
        return $session->get("sh_pr_method_id");
    }
    
    function setShippingPrice($price){
        $session =& JFactory::getSession();
        $session->set("jshop_price_shipping", $price);
    }
    
    function getShippingPrice() {
        $session =& JFactory::getSession();
        $price = $session->get("jshop_price_shipping");
        return floatval($price);
    }
    
    function setShippingPriceTax($price){
        $session =& JFactory::getSession();
        $session->set("jshop_price_shipping_tax", $price);
    }
    
    function getShippingPriceTax() {
        $session =& JFactory::getSession();
        $price = $session->get("jshop_price_shipping_tax");
        return floatval($price);
    }
    
    function setShippingPriceTaxPercent($price){
        $session =& JFactory::getSession();
        $session->set("jshop_price_shipping_tax_percent", $price);
    }
    
    function getShippingPriceTaxPercent() {
        $session =& JFactory::getSession();        
        return $session->get("jshop_price_shipping_tax_percent");
    }
        
    function getShippingNettoPrice() {
        return $this->getShippingPrice() / (1 + $this->getShippingPriceTaxPercent() / 100);
    }
    
    
    function setPaymentId($val){
        $session =& JFactory::getSession();
        $session->set("payment_method_id", $val);
    }
    
    function getPaymentId(){
        $session =& JFactory::getSession();
        return $session->get("payment_method_id");
    }
    
    function setPaymentPrice($val){
        $session =& JFactory::getSession();
        $session->set("jshop_payment_price", $val);
    }
    
    function getPaymentPrice(){
        $session =& JFactory::getSession();
        $price = $session->get("jshop_payment_price");
        return floatval($price);   
    }
    
    function setPaymentTax($val){
        $session =& JFactory::getSession();
        $session->set("jshop_payment_tax", $val);
    }
    
    function getPaymentTax(){
        $session =& JFactory::getSession();
        $price = $session->get("jshop_payment_tax");
        return $price;
    }
    
    function setPaymentTaxPercent($val){
        $session =& JFactory::getSession();
        $session->set("jshop_payment_tax_percent", $val);
    }
    
    function getPaymentTaxPercent(){
        $session =& JFactory::getSession();
        $price = $session->get("jshop_payment_tax_percent");
        return $price;
    }
    
    function setPaymentParams($val){
        $session =& JFactory::getSession();
        $session->set("pm_params", $val);
    }
    
    function getPaymentParams(){
        $session =& JFactory::getSession();
        $val = $session->get("pm_params");
        return $val;
    }    
    
    
    function getCouponId(){
        return $this->rabatt_id;
    }

    /*function calcNettoPrice(){
        foreach ($this->products as $key => $value) {
            $this->products[$key]['price_netto'] = round($value['price'] / (1 + $value['tax'] / 100), 2);
        }
    }*/

    function updateCartProductPrice() {
        foreach ($this->products as $key => $value) {
            $product = &JTable::getInstance('product', 'jshop');
            $product->load($this->products[$key]['product_id']);
            $attr_id = unserialize($value['attributes']);
            $product->setAttributeActive($attr_id);
            $this->products[$key]['price'] = $product->getPrice($this->products[$key]['quantity'], 1, 1, 1);
        }
        $this->loadPriceAndCountProducts();
        $this->reloadRabatValue();
        $this->saveToSession();
    }

    function add($product_id, $quantity, $attr_id){
        
        $jshopConfig = &JSFactory::getConfig();
        $attr_serialize = serialize($attr_id);
        
        if ($quantity <= 0) return 0;
        
        $currency = &JTable::getInstance('currency', 'jshop');
        $currency->load($jshopConfig->cur_currency);
        
        $product = &JTable::getInstance('product', 'jshop');
        $product->load($product_id);
        
        if ( (count($product->getRequireAttribute()) > count($attr_id)) || in_array(0, $attr_id)){
            JError::raiseNotice('', _JSHOP_SELECT_PRODUCT_OPTIONS);
            return 0;
        }
        
        $product->setAttributeActive($attr_id);
        $qtyInStock = $product->getQtyInStock();        
        
        $new_product = 1;
        foreach ($this->products as $key => $value) {
            if ($value['product_id'] == $product_id && $value['attributes'] == $attr_serialize) {
                $sum_quantity = $this->products[$key]['quantity'] + $quantity;
                                
                if ($jshopConfig->max_count_order_one_product && $sum_quantity > $jshopConfig->max_count_order_one_product){
                    JError::raiseNotice('', sprintf(_JSHOP_ERROR_MAX_COUNT_ORDER_ONE_PRODUCT, $jshopConfig->max_count_order_one_product));
                    return 0;
                }
                if ($jshopConfig->min_count_order_one_product && $sum_quantity < $jshopConfig->min_count_order_one_product){
                    JError::raiseNotice('', sprintf(_JSHOP_ERROR_MIN_COUNT_ORDER_ONE_PRODUCT, $jshopConfig->min_count_order_one_product));
                    return 0;
                }
                
                if ($jshopConfig->controler_buy_qty && ($sum_quantity > $qtyInStock)){
                    $balans = $qtyInStock - $this->products[$key]['quantity'];
                    if ($balans < 0) $balans = 0;
                    JError::raiseWarning('', sprintf(_JSHOP_ERROR_EXIST_QTY_PRODUCT_IN_CART, $this->products[$key]['quantity'], $balans));
                    return 0;
                }
                 
                $this->products[$key]['quantity'] = $sum_quantity;                
                $this->products[$key]['price'] = $product->getPrice($this->products[$key]['quantity'], 1, 1, 1);
                $new_product = 0;
                break;
            }
        }

        if($new_product) {
            
            if ($jshopConfig->max_count_order_one_product && $quantity > $jshopConfig->max_count_order_one_product){
                JError::raiseNotice('', sprintf(_JSHOP_ERROR_MAX_COUNT_ORDER_ONE_PRODUCT, $jshopConfig->max_count_order_one_product));
                return 0;
            }
            if ($jshopConfig->min_count_order_one_product && $quantity < $jshopConfig->min_count_order_one_product){
                JError::raiseNotice('', sprintf(_JSHOP_ERROR_MIN_COUNT_ORDER_ONE_PRODUCT, $jshopConfig->min_count_order_one_product));
                return 0;
            }                                   
            
            if ($jshopConfig->controler_buy_qty && ($quantity > $qtyInStock)){
                JError::raiseWarning('', sprintf(_JSHOP_ERROR_EXIST_QTY_PRODUCT, $qtyInStock));
                return 0;
            }
            
            $product->getDescription();            
            $temp_product['quantity'] = $quantity;
            $temp_product['product_id'] = $product_id;
            $temp_product['category_id'] = $product->getCategory();
            $temp_product['price'] = $product->getPrice($quantity, 1, 1, 1);
            $temp_product['tax'] = $product->getTax();
            $temp_product['tax_id'] = $product->product_tax_id;
            $temp_product['description'] = $product->short_description;
            $temp_product['product_name'] = $product->name;
            $temp_product['thumb_image'] = $product->product_thumb_image;
            $temp_product['ean'] = $product->getEan();
            $temp_product['attributes'] = $attr_serialize;
            $temp_product['attributes_value'] = array();
            $temp_product['weight'] = $product->product_weight;
            $temp_product['files'] = serialize($product->getSaleFiles());            
            $i = 0;
            if (is_array($attr_id) && count($attr_id)) {
                foreach ($attr_id as $key => $value) {
                    $attr = &JTable::getInstance('attribut', 'jshop');
                    $attr_v = &JTable::getInstance('attributvalue', 'jshop');
                    $temp_product['attributes_value'][$i]->attr = $attr->getName($key);
                    $temp_product['attributes_value'][$i++]->value = $attr_v->getName($value);                    
                }
            }
            $this->products[] = $temp_product;
        }
        
        $this->loadPriceAndCountProducts();
        $this->reloadRabatValue();
        $this->saveToSession();
        return 1;
    }

    function refresh($quantity) {
        $jshopConfig = &JSFactory::getConfig();        
        if (is_array($quantity) && count($quantity)) {            
            $lang = &JSFactory::getLang();
            $name = $lang->get('name');
            foreach ($quantity as $key => $value) {
                $value = intval($value);
                if ($value < 0) $value = 0;
                $product = &JTable::getInstance('product', 'jshop');
                $product->load($this->products[$key]['product_id']);
                $attr = unserialize($this->products[$key]['attributes']);
                $product->setAttributeActive($attr);
                $qtyInStock = $product->getQtyInStock();
                if ($jshopConfig->max_count_order_one_product && ($value > $jshopConfig->max_count_order_one_product)){
                    JError::raiseNotice('', sprintf(_JSHOP_ERROR_MAX_COUNT_ORDER_ONE_PRODUCT, $jshopConfig->max_count_order_one_product));
                    return 0;
                }
                if ($jshopConfig->min_count_order_one_product && ($value < $jshopConfig->min_count_order_one_product)){
                    JError::raiseNotice('', sprintf(_JSHOP_ERROR_MIN_COUNT_ORDER_ONE_PRODUCT, $jshopConfig->min_count_order_one_product));
                    return 0;
                }                
                if ($jshopConfig->controler_buy_qty && ($value > $qtyInStock)){
                    JError::raiseWarning('', sprintf(_JSHOP_ERROR_EXIST_QTY_PRODUCT_BASKET, $product->$name, $qtyInStock));
                    continue;
                }
                                
                $this->products[$key]['price'] = $product->getPrice($value, 1, 1, 1);
                $this->products[$key]['quantity'] = $value;                
                if($this->products[$key]['quantity'] == 0){
                    unset($this->products[$key]);
                }
                unset($product);
            }
        }
        $this->loadPriceAndCountProducts();
        $this->reloadRabatValue();
        $this->saveToSession();        
        return 1;
    }

    function getWeightProducts() {
        $weight_sum = 0;
        foreach ($this->products as $prod) {
            $weight_sum += $prod['weight'] * $prod['quantity'];
        }
        return $weight_sum;
    }

    function setRabatt($id, $type, $value, $tax) {        
        $this->rabatt_id = $id;
        $this->rabatt_type = $type;
        $this->rabatt_value = $value;
        $this->reloadRabatValue();    
        $this->saveToSession();    
    }
    
    function getSummForCalculeDiscount(){
        $jshopConfig = &JSFactory::getConfig();
        
        $sum = $this->price_product;
        if ($jshopConfig->discount_use_full_sum){
            if ($this->display_item_shipping) $sum += $this->getShippingPrice();
            if ($this->display_item_payment) $sum += $this->getPaymentPrice();
            if ($jshopConfig->display_price_front_current==1) $sum += $this->getTax($this->display_item_shipping, 1, $this->display_item_payment);
        }
        
        return $sum;
    }
    
    function reloadRabatValue(){
        $jshopConfig = &JSFactory::getConfig();
        
        if($this->rabatt_type == 1) {
            $this->rabatt_summ = $this->rabatt_value * $jshopConfig->currency_value; //value
        } else {
            $this->rabatt_summ = $this->rabatt_value / 100 * $this->getSummForCalculeDiscount(); //percent
        }
    }
    
    function updateDiscountData(){
        $this->reloadRabatValue();    
        $this->saveToSession();    
    }

    function addLinkToProducts($show_delete = 0, $type="cart") {
        foreach ($this->products as $key => $value) {
            $this->products[$key]['href'] = SEFLink('index.php?option=com_jshopping&controller=product&task=view&category_id='.$this->products[$key]['category_id'].'&product_id='.$value['product_id'], 1);
            if($show_delete){
                $this->products[$key]['href_delete'] = SEFLink('index.php?option=com_jshopping&controller='.$type.'&task=delete&number_id='.$key);
            }
            if ($type=="wishlist"){
                $this->products[$key]['remove_to_cart'] = SEFLink('index.php?option=com_jshopping&controller='.$type.'&task=remove_to_cart&number_id='.$key);                
            }
        }
    }
    
    function clear() {
        $session =& JFactory::getSession();
        $this->products = array();
        $this->rabatt = 0;
        $this->rabatt_value = 0;
        $this->rabatt_type = 0;
        $this->rabatt_summ = 0;
        $this->summ = 0;
        $this->count_product = 0;        
        $this->price_product = 0;        
        $session->set($this->type_cart, "");
        $session->set("pm_method", "");
        $session->set("pm_params", "");
        $session->set("payment_method_id", "");
        $session->set("shipping_method_id", "");
        $session->set("jshop_price_shipping", "");
    }

    function addOrderItem($order_id) {
        $arrProd = array();
        foreach ($this->products as $key => $value) {
            $order_item = &JTable::getInstance('orderItem', 'jshop');            
            $order_item->order_id = $order_id;
            $order_item->product_id = $value['product_id'];
            $order_item->product_ean = $value['ean'];
            $order_item->product_name = $value['product_name'];
            $order_item->product_quantity = $value['quantity'];
            $order_item->product_item_price = $value['price'];
            $order_item->product_tax = $value['tax'];
            $order_item->product_attributes = $attributes_value = '';
            $order_item->files = $value['files'];
            $order_item->weight = $value['weight'];
            if(isset($value['attributes_value'])) {
                foreach ($value['attributes_value'] as $attr) {
                    $attributes_value .= $attr->attr . ": " . $attr->value . "\n";
                }
            }
            $order_item->product_attributes = $attributes_value;
            $order_item->store();
            
            $arrProd[$key]['quantity'] = $value['quantity'];
            $arrProd[$key]['product_id'] = $value['product_id'];
            $arrProd[$key]['attr'] = unserialize($value[attributes]);
        }

        // update count product in shop db
        $product = &JTable::getInstance('product', 'jshop');
        $product->updateProductInStock($arrProd);
    }

    function delete($number_id) {
        unset($this->products[$number_id]);
        $this->saveToSession();
    }

    function saveToSession() {
        $session =& JFactory::getSession();
        $session->set($this->type_cart, serialize($this));        
        $_tempcart = &JModel::getInstance('tempcart', 'jshop');
        $_tempcart->insertTempCart($this);        
    }

}

?>